/**
 * 1Gb API
 *  API для работы с хостингом позволяет автоматизировать управление ресурсами и анализ данных.  ## Примеры использования API хостинга:  * Отслеживание состояния аккаунта и своевременный анализ уведомлений * Автоматическое создание, удаление, конфигурирование ресурсов * Доступ к данным внутреннего мониторинга 1Gb.ru, анализ качества работы VDS * Автоматизация типовых реакций на проблемы ресурсов и хостинга   Доступ к API хостинга активен в любом оплаченном тарифном плане. Для тестовых или бесплатных аккаунтов API не работает.   ## Принципы работы и примеры  Доступ происходит по протоколу HTTPS по базовому адресу https://www.1gb.ru/api/. Параметры большинства запросов можно передавать с помощью GET или POST параметров. Ответ содержит объект или массив объектов по стандарту JSON.  Перед началом работы с API требуется получить token для дальнейшей авторизации. Это делается следующим образом (приведены примеры использования GET параметров):  1. https://www.1gb.ru/api/auth/start?login=[логин_кабинета] - возвращает в ответ string, содержащий соль 2. https://www.1gb.ru/api/auth/login?login=[логин_кабинета]&salt=[соль]&response=[response] - возвращает в ответ string, содержащий token; псевдокод для вычисления response на PHP: *md5($password.$salt.\"\\n\")* (сумма md5 строки \"пароль+соль+символ-перевода-строки\")  Последний запрос возвращает string, в нем token, его нужно запомнить и использовать для последующей авторизации. Token утрачивает силу при смене главного пароля аккаунта, существует также возможность деактивировать отдельные token-ы со страницы кабинета \"смена главного пароля аккаунта\".  Примеры дальнейших запросов:      https://www.1gb.ru/api/billing/info?_token_=[запомненный token] - получение общих данных аккаунта   Ответы API с HTTP кодом 200 обозначают успешное исполнение операции. В ответном JSON может содержаться два разных типа:  * [ \"string\" ]: либо просто \"OK\", либо \"[число]\" (необходимо привести к int), если возвращается ID созданного объекта * [ { ... } , { ... } ] (массив объектов): если запрос возвращает список из 0 или более структур (хеш \"поле\":\"значение\").   Другие коды (больше 200) обозначают ошибку, при этом тело ответа содержит string с объяснением, пример: \"ERROR: vds.missing\".  ## Команды API и общие соглашения  Большинство команд API, таких как /list, возвращают внутренние структуры из базы данных хостинга, которые содержат сотни полей. Документировать их трудоемко, поэтому рекомендуем просто смотреть на вывод соответствующих команд и анализировать структуры данных по очевидным названиям полей.  В том случае, если трактовка полей вызывает затруднения, пишите на support@1gb.ru, поможем разобраться.  ## Общедоступные на данный момент команды  https://www.1gb.ru/api + адрес из списка ниже. Обязательный параметр каждой команды (кроме этапа авторизации) - _token_. Остальные параметры приведены после команды.  
 *
 * OpenAPI spec version: 2.0.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

import {Http, Headers, RequestOptionsArgs, Response, URLSearchParams} from '@angular/http';
import {Injectable, Optional} from '@angular/core';
import {Observable} from 'rxjs/Observable';
import * as models from '../model/models';
import 'rxjs/Rx';

/* tslint:disable:no-unused-variable member-ordering */

'use strict';

@Injectable()
export class DNSApi {
    protected basePath = 'https://www.1gb.ru/api';
    public defaultHeaders : Headers = new Headers();

    constructor(protected http: Http, @Optional() basePath: string) {
        if (basePath) {
            this.basePath = basePath;
        }
    }

    /**
     * Создание записи домена
     * 
     * @param token_ Ключ доступа, полученный при авторизации
     * @param addDnsZone зона, которую необходимо создать
     * @param addDnsRecord 
     * @param iisSiteForDns ID сайта из /website/list, либо IP-адрес виртуального сервера, к которому необходимо сделать привязку
     * @param bindOnly 
     */
    public dnsAddGet (token_: string, addDnsZone: string, addDnsRecord?: string, iisSiteForDns?: string, bindOnly?: boolean, extraHttpRequestParams?: any ) : Observable<string> {
        const path = this.basePath + '/dns/add';

        let queryParameters = new URLSearchParams();
        let headerParams = this.defaultHeaders;
        // verify required parameter 'token_' is not null or undefined
        if (token_ === null || token_ === undefined) {
            throw new Error('Required parameter token_ was null or undefined when calling dnsAddGet.');
        }
        // verify required parameter 'addDnsZone' is not null or undefined
        if (addDnsZone === null || addDnsZone === undefined) {
            throw new Error('Required parameter addDnsZone was null or undefined when calling dnsAddGet.');
        }
        if (token_ !== undefined) {
            queryParameters.set('_token_', token_);
        }

        if (addDnsZone !== undefined) {
            queryParameters.set('add_dns_zone', addDnsZone);
        }

        if (addDnsRecord !== undefined) {
            queryParameters.set('add_dns_record', addDnsRecord);
        }

        if (iisSiteForDns !== undefined) {
            queryParameters.set('iis_site_for_dns', iisSiteForDns);
        }

        if (bindOnly !== undefined) {
            queryParameters.set('bind_only', bindOnly);
        }

        let requestOptions: RequestOptionsArgs = {
            method: 'GET',
            headers: headerParams,
            search: queryParameters
        };

        return this.http.request(path, requestOptions)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * Привязка одного домена к другому
     * 
     * @param token_ Ключ доступа, полученный при авторизации
     * @param key_ ID домена из списка /dns/list
     * @param bindTo домен, к которому необходимо сделать привязку
     */
    public dnsBindGet (token_: string, key_: number, bindTo?: string, extraHttpRequestParams?: any ) : Observable<string> {
        const path = this.basePath + '/dns/bind';

        let queryParameters = new URLSearchParams();
        let headerParams = this.defaultHeaders;
        // verify required parameter 'token_' is not null or undefined
        if (token_ === null || token_ === undefined) {
            throw new Error('Required parameter token_ was null or undefined when calling dnsBindGet.');
        }
        // verify required parameter 'key_' is not null or undefined
        if (key_ === null || key_ === undefined) {
            throw new Error('Required parameter key_ was null or undefined when calling dnsBindGet.');
        }
        if (token_ !== undefined) {
            queryParameters.set('_token_', token_);
        }

        if (key_ !== undefined) {
            queryParameters.set('_key_', key_);
        }

        if (bindTo !== undefined) {
            queryParameters.set('bind_to', bindTo);
        }

        let requestOptions: RequestOptionsArgs = {
            method: 'GET',
            headers: headerParams,
            search: queryParameters
        };

        return this.http.request(path, requestOptions)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * Получить список доменных имён
     * 
     * @param token_ Ключ доступа, полученный при авторизации
     */
    public dnsListGet (token_: string, extraHttpRequestParams?: any ) : Observable<Array<models.InlineResponse2003>> {
        const path = this.basePath + '/dns/list';

        let queryParameters = new URLSearchParams();
        let headerParams = this.defaultHeaders;
        // verify required parameter 'token_' is not null or undefined
        if (token_ === null || token_ === undefined) {
            throw new Error('Required parameter token_ was null or undefined when calling dnsListGet.');
        }
        if (token_ !== undefined) {
            queryParameters.set('_token_', token_);
        }

        let requestOptions: RequestOptionsArgs = {
            method: 'GET',
            headers: headerParams,
            search: queryParameters
        };

        return this.http.request(path, requestOptions)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * Информация по продлению доменов
     * 
     * @param token_ Ключ доступа, полученный при авторизации
     */
    public dnsProlongListGet (token_: string, extraHttpRequestParams?: any ) : Observable<Array<models.InlineResponse2004>> {
        const path = this.basePath + '/dns/prolong/list';

        let queryParameters = new URLSearchParams();
        let headerParams = this.defaultHeaders;
        // verify required parameter 'token_' is not null or undefined
        if (token_ === null || token_ === undefined) {
            throw new Error('Required parameter token_ was null or undefined when calling dnsProlongListGet.');
        }
        if (token_ !== undefined) {
            queryParameters.set('_token_', token_);
        }

        let requestOptions: RequestOptionsArgs = {
            method: 'GET',
            headers: headerParams,
            search: queryParameters
        };

        return this.http.request(path, requestOptions)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * Редактирование \&quot;сырой\&quot; зоны
     * 
     * @param token_ Ключ доступа, полученный при авторизации
     * @param key_ ID домена из /dns/list
     * @param sDel Значение &#39;1&#39; сообщает, что запись необходимо удалить
     * @param sAdd Значение &#39;1&#39; сообщает, что запись необходимо создать
     * @param dnsType Тип записи: A, MX, CNAME, AAAA, NS, TXT, SRV
     * @param dnsName Имя записи, либо &#39;@&#39; для корневой
     * @param dnsValue Содержание записи (для A это IP-адрес, для CNAME имя, для MX приоритет и назначение)
     */
    public dnsRawGet (token_: string, key_: number, sDel: number, sAdd: number, dnsType: string, dnsName: string, dnsValue: string, extraHttpRequestParams?: any ) : Observable<string> {
        const path = this.basePath + '/dns/raw';

        let queryParameters = new URLSearchParams();
        let headerParams = this.defaultHeaders;
        // verify required parameter 'token_' is not null or undefined
        if (token_ === null || token_ === undefined) {
            throw new Error('Required parameter token_ was null or undefined when calling dnsRawGet.');
        }
        // verify required parameter 'key_' is not null or undefined
        if (key_ === null || key_ === undefined) {
            throw new Error('Required parameter key_ was null or undefined when calling dnsRawGet.');
        }
        // verify required parameter 'sDel' is not null or undefined
        if (sDel === null || sDel === undefined) {
            throw new Error('Required parameter sDel was null or undefined when calling dnsRawGet.');
        }
        // verify required parameter 'sAdd' is not null or undefined
        if (sAdd === null || sAdd === undefined) {
            throw new Error('Required parameter sAdd was null or undefined when calling dnsRawGet.');
        }
        // verify required parameter 'dnsType' is not null or undefined
        if (dnsType === null || dnsType === undefined) {
            throw new Error('Required parameter dnsType was null or undefined when calling dnsRawGet.');
        }
        // verify required parameter 'dnsName' is not null or undefined
        if (dnsName === null || dnsName === undefined) {
            throw new Error('Required parameter dnsName was null or undefined when calling dnsRawGet.');
        }
        // verify required parameter 'dnsValue' is not null or undefined
        if (dnsValue === null || dnsValue === undefined) {
            throw new Error('Required parameter dnsValue was null or undefined when calling dnsRawGet.');
        }
        if (token_ !== undefined) {
            queryParameters.set('_token_', token_);
        }

        if (key_ !== undefined) {
            queryParameters.set('_key_', key_);
        }

        if (sDel !== undefined) {
            queryParameters.set('s_del', sDel);
        }

        if (sAdd !== undefined) {
            queryParameters.set('s_add', sAdd);
        }

        if (dnsType !== undefined) {
            queryParameters.set('dns_type', dnsType);
        }

        if (dnsName !== undefined) {
            queryParameters.set('dns_name', dnsName);
        }

        if (dnsValue !== undefined) {
            queryParameters.set('dns_value', dnsValue);
        }

        let requestOptions: RequestOptionsArgs = {
            method: 'GET',
            headers: headerParams,
            search: queryParameters
        };

        return this.http.request(path, requestOptions)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * Редактировать DNS-зону
     * 
     * @param token_ Ключ доступа, полученный при авторизации
     * @param key_ ID домена из /dns/list
     * @param managedMx Значение &#39;1&#39;, если необходимо включить поддержку на MX-серверах хостинга и &#39;0&#39;, если выключить
     * @param updManagedMx Значение &#39;1&#39; подтверждает операцию
     */
    public dnsRawManagedmxGet (token_: string, key_: number, managedMx: number, updManagedMx: number, extraHttpRequestParams?: any ) : Observable<string> {
        const path = this.basePath + '/dns/raw/managedmx';

        let queryParameters = new URLSearchParams();
        let headerParams = this.defaultHeaders;
        // verify required parameter 'token_' is not null or undefined
        if (token_ === null || token_ === undefined) {
            throw new Error('Required parameter token_ was null or undefined when calling dnsRawManagedmxGet.');
        }
        // verify required parameter 'key_' is not null or undefined
        if (key_ === null || key_ === undefined) {
            throw new Error('Required parameter key_ was null or undefined when calling dnsRawManagedmxGet.');
        }
        // verify required parameter 'managedMx' is not null or undefined
        if (managedMx === null || managedMx === undefined) {
            throw new Error('Required parameter managedMx was null or undefined when calling dnsRawManagedmxGet.');
        }
        // verify required parameter 'updManagedMx' is not null or undefined
        if (updManagedMx === null || updManagedMx === undefined) {
            throw new Error('Required parameter updManagedMx was null or undefined when calling dnsRawManagedmxGet.');
        }
        if (token_ !== undefined) {
            queryParameters.set('_token_', token_);
        }

        if (key_ !== undefined) {
            queryParameters.set('_key_', key_);
        }

        if (managedMx !== undefined) {
            queryParameters.set('managed_mx', managedMx);
        }

        if (updManagedMx !== undefined) {
            queryParameters.set('upd_managed_mx', updManagedMx);
        }

        let requestOptions: RequestOptionsArgs = {
            method: 'GET',
            headers: headerParams,
            search: queryParameters
        };

        return this.http.request(path, requestOptions)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

}
