/**
 * 1Gb API
 *  API для работы с хостингом позволяет автоматизировать управление ресурсами и анализ данных.  ## Примеры использования API хостинга:  * Отслеживание состояния аккаунта и своевременный анализ уведомлений * Автоматическое создание, удаление, конфигурирование ресурсов * Доступ к данным внутреннего мониторинга 1Gb.ru, анализ качества работы VDS * Автоматизация типовых реакций на проблемы ресурсов и хостинга   Доступ к API хостинга активен в любом оплаченном тарифном плане. Для тестовых или бесплатных аккаунтов API не работает.   ## Принципы работы и примеры  Доступ происходит по протоколу HTTPS по базовому адресу https://www.1gb.ru/api/. Параметры большинства запросов можно передавать с помощью GET или POST параметров. Ответ содержит объект или массив объектов по стандарту JSON.  Перед началом работы с API требуется получить token для дальнейшей авторизации. Это делается следующим образом (приведены примеры использования GET параметров):  1. https://www.1gb.ru/api/auth/start?login=[логин_кабинета] - возвращает в ответ string, содержащий соль 2. https://www.1gb.ru/api/auth/login?login=[логин_кабинета]&salt=[соль]&response=[response] - возвращает в ответ string, содержащий token; псевдокод для вычисления response на PHP: *md5($password.$salt.\"\\n\")* (сумма md5 строки \"пароль+соль+символ-перевода-строки\")  Последний запрос возвращает string, в нем token, его нужно запомнить и использовать для последующей авторизации. Token утрачивает силу при смене главного пароля аккаунта, существует также возможность деактивировать отдельные token-ы со страницы кабинета \"смена главного пароля аккаунта\".  Примеры дальнейших запросов:      https://www.1gb.ru/api/billing/info?_token_=[запомненный token] - получение общих данных аккаунта   Ответы API с HTTP кодом 200 обозначают успешное исполнение операции. В ответном JSON может содержаться два разных типа:  * [ \"string\" ]: либо просто \"OK\", либо \"[число]\" (необходимо привести к int), если возвращается ID созданного объекта * [ { ... } , { ... } ] (массив объектов): если запрос возвращает список из 0 или более структур (хеш \"поле\":\"значение\").   Другие коды (больше 200) обозначают ошибку, при этом тело ответа содержит string с объяснением, пример: \"ERROR: vds.missing\".  ## Команды API и общие соглашения  Большинство команд API, таких как /list, возвращают внутренние структуры из базы данных хостинга, которые содержат сотни полей. Документировать их трудоемко, поэтому рекомендуем просто смотреть на вывод соответствующих команд и анализировать структуры данных по очевидным названиям полей.  В том случае, если трактовка полей вызывает затруднения, пишите на support@1gb.ru, поможем разобраться.  ## Общедоступные на данный момент команды  https://www.1gb.ru/api + адрес из списка ниже. Обязательный параметр каждой команды (кроме этапа авторизации) - _token_. Остальные параметры приведены после команды.  
 *
 * OpenAPI spec version: 2.0.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

import {Http, Headers, RequestOptionsArgs, Response, URLSearchParams} from '@angular/http';
import {Injectable, Optional} from '@angular/core';
import {Observable} from 'rxjs/Observable';
import * as models from '../model/models';
import 'rxjs/Rx';

/* tslint:disable:no-unused-variable member-ordering */

'use strict';

@Injectable()
export class DefaultApi {
    protected basePath = 'https://www.1gb.ru/api';
    public defaultHeaders : Headers = new Headers();

    constructor(protected http: Http, @Optional() basePath: string) {
        if (basePath) {
            this.basePath = basePath;
        }
    }

    /**
     * Аккаунт: баланс
     * Возвращает текущий баланс аккаунта
     * @param token_ Ключ доступа, полученный при авторизации
     */
    public balanceGet (token_: string, extraHttpRequestParams?: any ) : Observable<number> {
        const path = this.basePath + '/balance';

        let queryParameters = new URLSearchParams();
        let headerParams = this.defaultHeaders;
        // verify required parameter 'token_' is not null or undefined
        if (token_ === null || token_ === undefined) {
            throw new Error('Required parameter token_ was null or undefined when calling balanceGet.');
        }
        if (token_ !== undefined) {
            queryParameters.set('_token_', token_);
        }

        let requestOptions: RequestOptionsArgs = {
            method: 'GET',
            headers: headerParams,
            search: queryParameters
        };

        return this.http.request(path, requestOptions)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * Аккаунт: баланс аккаунта лицензий
     * Возвращает текущий баланс аккаунта лицензий
     * @param token_ Ключ доступа, полученный при авторизации
     */
    public balanceLicGet (token_: string, extraHttpRequestParams?: any ) : Observable<number> {
        const path = this.basePath + '/balance.lic';

        let queryParameters = new URLSearchParams();
        let headerParams = this.defaultHeaders;
        // verify required parameter 'token_' is not null or undefined
        if (token_ === null || token_ === undefined) {
            throw new Error('Required parameter token_ was null or undefined when calling balanceLicGet.');
        }
        if (token_ !== undefined) {
            queryParameters.set('_token_', token_);
        }

        let requestOptions: RequestOptionsArgs = {
            method: 'GET',
            headers: headerParams,
            search: queryParameters
        };

        return this.http.request(path, requestOptions)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * Информация по дебету аккаунта
     * Данный запрос позволяет получить информацию по планируемым датам наступления негативного баланса и отключения
     * @param token_ Ключ доступа, полученный при авторизации
     */
    public billingDebtGet (token_: string, extraHttpRequestParams?: any ) : Observable<Array<models.InlineResponse200>> {
        const path = this.basePath + '/billing/debt';

        let queryParameters = new URLSearchParams();
        let headerParams = this.defaultHeaders;
        // verify required parameter 'token_' is not null or undefined
        if (token_ === null || token_ === undefined) {
            throw new Error('Required parameter token_ was null or undefined when calling billingDebtGet.');
        }
        if (token_ !== undefined) {
            queryParameters.set('_token_', token_);
        }

        let requestOptions: RequestOptionsArgs = {
            method: 'GET',
            headers: headerParams,
            search: queryParameters
        };

        return this.http.request(path, requestOptions)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * Информация об аккаунте
     * Этот запрос позволяет получить информацию об аккаунте, а также базовую статистику использования ресурсов.
     * @param token_ Ключ доступа, полученный при авторизации
     */
    public billingInfoGet (token_: string, extraHttpRequestParams?: any ) : Observable<Array<models.InlineResponse2001>> {
        const path = this.basePath + '/billing/info';

        let queryParameters = new URLSearchParams();
        let headerParams = this.defaultHeaders;
        // verify required parameter 'token_' is not null or undefined
        if (token_ === null || token_ === undefined) {
            throw new Error('Required parameter token_ was null or undefined when calling billingInfoGet.');
        }
        if (token_ !== undefined) {
            queryParameters.set('_token_', token_);
        }

        let requestOptions: RequestOptionsArgs = {
            method: 'GET',
            headers: headerParams,
            search: queryParameters
        };

        return this.http.request(path, requestOptions)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * Получить ограничения аккаунта
     * 
     * @param token_ Ключ доступа, полученный при авторизации
     */
    public billingLimitsGet (token_: string, extraHttpRequestParams?: any ) : Observable<models._> {
        const path = this.basePath + '/billing/limits';

        let queryParameters = new URLSearchParams();
        let headerParams = this.defaultHeaders;
        // verify required parameter 'token_' is not null or undefined
        if (token_ === null || token_ === undefined) {
            throw new Error('Required parameter token_ was null or undefined when calling billingLimitsGet.');
        }
        if (token_ !== undefined) {
            queryParameters.set('_token_', token_);
        }

        let requestOptions: RequestOptionsArgs = {
            method: 'GET',
            headers: headerParams,
            search: queryParameters
        };

        return this.http.request(path, requestOptions)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * Информация по продлению доменов
     * 
     * @param token_ Ключ доступа, полученный при авторизации
     */
    public dnsProlongListGet (token_: string, extraHttpRequestParams?: any ) : Observable<Array<models.InlineResponse2004>> {
        const path = this.basePath + '/dns/prolong/list';

        let queryParameters = new URLSearchParams();
        let headerParams = this.defaultHeaders;
        // verify required parameter 'token_' is not null or undefined
        if (token_ === null || token_ === undefined) {
            throw new Error('Required parameter token_ was null or undefined when calling dnsProlongListGet.');
        }
        if (token_ !== undefined) {
            queryParameters.set('_token_', token_);
        }

        let requestOptions: RequestOptionsArgs = {
            method: 'GET',
            headers: headerParams,
            search: queryParameters
        };

        return this.http.request(path, requestOptions)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * Создание почтового ящика
     * 
     * @param token_ Ключ доступа, полученный при авторизации
     * @param addEmail Адрес почтового ящика, который необходимо создать
     */
    public emailAddGet (token_: string, addEmail: string, extraHttpRequestParams?: any ) : Observable<string> {
        const path = this.basePath + '/email/add';

        let queryParameters = new URLSearchParams();
        let headerParams = this.defaultHeaders;
        // verify required parameter 'token_' is not null or undefined
        if (token_ === null || token_ === undefined) {
            throw new Error('Required parameter token_ was null or undefined when calling emailAddGet.');
        }
        // verify required parameter 'addEmail' is not null or undefined
        if (addEmail === null || addEmail === undefined) {
            throw new Error('Required parameter addEmail was null or undefined when calling emailAddGet.');
        }
        if (token_ !== undefined) {
            queryParameters.set('_token_', token_);
        }

        if (addEmail !== undefined) {
            queryParameters.set('add_email', addEmail);
        }

        let requestOptions: RequestOptionsArgs = {
            method: 'GET',
            headers: headerParams,
            search: queryParameters
        };

        return this.http.request(path, requestOptions)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * Удаление псевдонимов почтовых ящиков
     * 
     * @param token_ Ключ доступа, полученный при авторизации
     * @param key_ Адрес почтового ящика, подлежащего удалению
     */
    public emailAliasDeleteGet (token_: string, key_: string, extraHttpRequestParams?: any ) : Observable<string> {
        const path = this.basePath + '/email/alias/delete';

        let queryParameters = new URLSearchParams();
        let headerParams = this.defaultHeaders;
        // verify required parameter 'token_' is not null or undefined
        if (token_ === null || token_ === undefined) {
            throw new Error('Required parameter token_ was null or undefined when calling emailAliasDeleteGet.');
        }
        // verify required parameter 'key_' is not null or undefined
        if (key_ === null || key_ === undefined) {
            throw new Error('Required parameter key_ was null or undefined when calling emailAliasDeleteGet.');
        }
        if (token_ !== undefined) {
            queryParameters.set('_token_', token_);
        }

        if (key_ !== undefined) {
            queryParameters.set('_key_', key_);
        }

        let requestOptions: RequestOptionsArgs = {
            method: 'GET',
            headers: headerParams,
            search: queryParameters
        };

        return this.http.request(path, requestOptions)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * Получить список псевдонимов почтовых ящиков
     * 
     * @param token_ Ключ доступа, полученный при авторизации
     */
    public emailAliasListGet (token_: string, extraHttpRequestParams?: any ) : Observable<Array<models.InlineResponse2005>> {
        const path = this.basePath + '/email/alias/list';

        let queryParameters = new URLSearchParams();
        let headerParams = this.defaultHeaders;
        // verify required parameter 'token_' is not null or undefined
        if (token_ === null || token_ === undefined) {
            throw new Error('Required parameter token_ was null or undefined when calling emailAliasListGet.');
        }
        if (token_ !== undefined) {
            queryParameters.set('_token_', token_);
        }

        let requestOptions: RequestOptionsArgs = {
            method: 'GET',
            headers: headerParams,
            search: queryParameters
        };

        return this.http.request(path, requestOptions)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * Удаление почтового ящика
     * 
     * @param token_ Ключ доступа, полученный при авторизации
     * @param key_ Адрес почтового ящика, подлежащего удалению
     */
    public emailDeleteGet (token_: string, key_: string, extraHttpRequestParams?: any ) : Observable<string> {
        const path = this.basePath + '/email/delete';

        let queryParameters = new URLSearchParams();
        let headerParams = this.defaultHeaders;
        // verify required parameter 'token_' is not null or undefined
        if (token_ === null || token_ === undefined) {
            throw new Error('Required parameter token_ was null or undefined when calling emailDeleteGet.');
        }
        // verify required parameter 'key_' is not null or undefined
        if (key_ === null || key_ === undefined) {
            throw new Error('Required parameter key_ was null or undefined when calling emailDeleteGet.');
        }
        if (token_ !== undefined) {
            queryParameters.set('_token_', token_);
        }

        if (key_ !== undefined) {
            queryParameters.set('_key_', key_);
        }

        let requestOptions: RequestOptionsArgs = {
            method: 'GET',
            headers: headerParams,
            search: queryParameters
        };

        return this.http.request(path, requestOptions)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * Получить список почтовых ящиков
     * 
     * @param token_ Ключ доступа, полученный при авторизации
     */
    public emailListGet (token_: string, extraHttpRequestParams?: any ) : Observable<Array<models.InlineResponse2006>> {
        const path = this.basePath + '/email/list';

        let queryParameters = new URLSearchParams();
        let headerParams = this.defaultHeaders;
        // verify required parameter 'token_' is not null or undefined
        if (token_ === null || token_ === undefined) {
            throw new Error('Required parameter token_ was null or undefined when calling emailListGet.');
        }
        if (token_ !== undefined) {
            queryParameters.set('_token_', token_);
        }

        let requestOptions: RequestOptionsArgs = {
            method: 'GET',
            headers: headerParams,
            search: queryParameters
        };

        return this.http.request(path, requestOptions)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * Идентификатор последнего уведомления в аудите
     * 
     * @param token_ Ключ доступа, полученный при авторизации
     */
    public updatesLastGet (token_: string, extraHttpRequestParams?: any ) : Observable<number> {
        const path = this.basePath + '/updates/last';

        let queryParameters = new URLSearchParams();
        let headerParams = this.defaultHeaders;
        // verify required parameter 'token_' is not null or undefined
        if (token_ === null || token_ === undefined) {
            throw new Error('Required parameter token_ was null or undefined when calling updatesLastGet.');
        }
        if (token_ !== undefined) {
            queryParameters.set('_token_', token_);
        }

        let requestOptions: RequestOptionsArgs = {
            method: 'GET',
            headers: headerParams,
            search: queryParameters
        };

        return this.http.request(path, requestOptions)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * Список записей аудита
     * 
     * @param token_ Ключ доступа, полученный при авторизации
     * @param key_ ID первой записи для показа или 0 для показа всех записей
     */
    public updatesListGet (token_: string, key_: number, extraHttpRequestParams?: any ) : Observable<Array<models.InlineResponse20010>> {
        const path = this.basePath + '/updates/list';

        let queryParameters = new URLSearchParams();
        let headerParams = this.defaultHeaders;
        // verify required parameter 'token_' is not null or undefined
        if (token_ === null || token_ === undefined) {
            throw new Error('Required parameter token_ was null or undefined when calling updatesListGet.');
        }
        // verify required parameter 'key_' is not null or undefined
        if (key_ === null || key_ === undefined) {
            throw new Error('Required parameter key_ was null or undefined when calling updatesListGet.');
        }
        if (token_ !== undefined) {
            queryParameters.set('_token_', token_);
        }

        if (key_ !== undefined) {
            queryParameters.set('_key_', key_);
        }

        let requestOptions: RequestOptionsArgs = {
            method: 'GET',
            headers: headerParams,
            search: queryParameters
        };

        return this.http.request(path, requestOptions)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * Удаление сайта
     * 
     * @param token_ Ключ доступа, полученный при авторизации
     * @param key_ ID сайта, полученный из /website/list
     */
    public websiteDeleteGet (token_: string, key_: string, extraHttpRequestParams?: any ) : Observable<string> {
        const path = this.basePath + '/website/delete';

        let queryParameters = new URLSearchParams();
        let headerParams = this.defaultHeaders;
        // verify required parameter 'token_' is not null or undefined
        if (token_ === null || token_ === undefined) {
            throw new Error('Required parameter token_ was null or undefined when calling websiteDeleteGet.');
        }
        // verify required parameter 'key_' is not null or undefined
        if (key_ === null || key_ === undefined) {
            throw new Error('Required parameter key_ was null or undefined when calling websiteDeleteGet.');
        }
        if (token_ !== undefined) {
            queryParameters.set('_token_', token_);
        }

        if (key_ !== undefined) {
            queryParameters.set('_key_', key_);
        }

        let requestOptions: RequestOptionsArgs = {
            method: 'GET',
            headers: headerParams,
            search: queryParameters
        };

        return this.http.request(path, requestOptions)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

    /**
     * Список сайтов аккаунта
     * 
     * @param token_ Ключ доступа, полученный при авторизации
     */
    public websiteListGet (token_: string, extraHttpRequestParams?: any ) : Observable<Array<models.InlineResponse20014>> {
        const path = this.basePath + '/website/list';

        let queryParameters = new URLSearchParams();
        let headerParams = this.defaultHeaders;
        // verify required parameter 'token_' is not null or undefined
        if (token_ === null || token_ === undefined) {
            throw new Error('Required parameter token_ was null or undefined when calling websiteListGet.');
        }
        if (token_ !== undefined) {
            queryParameters.set('_token_', token_);
        }

        let requestOptions: RequestOptionsArgs = {
            method: 'GET',
            headers: headerParams,
            search: queryParameters
        };

        return this.http.request(path, requestOptions)
            .map((response: Response) => {
                if (response.status === 204) {
                    return undefined;
                } else {
                    return response.json();
                }
            });
    }

}
